package ch.std.jumpstart.mock;

import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.get;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.skyscreamer.jsonassert.JSONAssert;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.domain.EntityScan;
import org.springframework.boot.test.autoconfigure.web.servlet.WebMvcTest;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;
import org.springframework.http.MediaType;
import org.springframework.test.context.ActiveProfiles;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.test.web.servlet.MvcResult;

import ch.std.jumpstart.rest.CityAutoCompleteController;

@RunWith(SpringRunner.class)
@WebMvcTest(CityAutoCompleteController.class)
@EntityScan(basePackages = "ch.std.jumpstart")
@ComponentScan(basePackages = "ch.std.jumpstart")
@EnableJpaRepositories("ch.std.jumpstart")
@ActiveProfiles("test")
public class JumpStartMockTests {
	
	@Autowired
	private MockMvc mvc;
	
	@Test
	public void testCityAutoCompleteController() throws Exception {
		MvcResult mvcResult = mvc.perform(get("/rest/auto/cities?value=Bern")
				.contentType(MediaType.APPLICATION_JSON)).andExpect(status().isOk()).andReturn();
		String expected = "[Bern]";
		String actual = mvcResult.getResponse().getContentAsString();
		JSONAssert.assertEquals(expected, actual, false);		
	}

}
